#include "mpi-test.h"

double Chaos ( int iSIZE , int TIMES)
{
	char *recvBuffer[512], *sendBuffer[512];
	int iSize, iCount, iProcCount, iNumberOfProc, iMyRank, iRemoteProcess;
	double dTime1, dTime2, dTime, dLatency;
	MPI_Status  status;
	MPI_Status *statuses;
	MPI_Request *sendRequests, *recvRequests;
	int pool_size,rank,remote,i_am_the_master;
	int i;
	double Rate;
	MPI_Comm comm = MPI_COMM_WORLD;

	MPI_Comm_size(comm, &iNumberOfProc );
	MPI_Comm_rank(comm, &iMyRank );
	pool_size = iNumberOfProc;
	rank = iMyRank;
	i_am_the_master = (rank == 0);

	statuses     = ( MPI_Status * ) malloc (pool_size * sizeof(MPI_Status) );
   	sendRequests = ( MPI_Request * ) malloc (pool_size * sizeof(MPI_Request) );
   	recvRequests = ( MPI_Request  * ) malloc (pool_size * sizeof(MPI_Request) );

	for(i = 0; i < pool_size; i ++) {
		recvBuffer[i] = (char*) malloc(iSIZE);		
		sendBuffer[i] = (char*) malloc(iSIZE);
		if(recvBuffer[i] == NULL || sendBuffer[i] == NULL)
			finish("Can't allocate buffer");
		}
 


	MPI_Barrier(comm);

	iSize = iSIZE;
	dTime1 = Wtime();

	for ( iCount = 0; iCount < TIMES; iCount ++)
	{
		for(remote = rank + 1; remote < pool_size; remote ++)
				MPI_Isend(sendBuffer[remote],iSize,MPI_CHAR,
						remote,iTAG,comm,&sendRequests[remote]);

			for(remote = 0; remote < pool_size; remote ++)
				if(remote != rank)
					MPI_Irecv (recvBuffer[remote], iSize,MPI_CHAR,
						remote,iTAG,comm,&recvRequests[remote]);

			recvRequests[rank] = MPI_REQUEST_NULL;
			sendRequests[rank] = MPI_REQUEST_NULL;

			for(i = 0; i < pool_size - 1; i ++) {
				MPI_Waitany(pool_size,recvRequests,&remote,&status);
				if(remote == MPI_UNDEFINED)
					finish("Undefined return code of MPI_Waitany");
				if(remote < rank)
				MPI_Isend(sendBuffer[remote],iSize,MPI_CHAR,
						remote,iTAG,comm,&sendRequests[remote]);
     			}

			MPI_Waitall(pool_size,sendRequests,statuses);	

	    } /* End of for */ /* Close iteration count */

		MPI_Barrier(comm);
		dTime2 = Wtime ( ); /* Timing for iMyRank = iROOT */
		dTime = dTime2 - dTime1;


      /*  Compute transfer rate   */

		Rate = ( (double) iSize * 2.0 * TIMES) / (dTime * MEGABYTE);

	for(i = 0; i < pool_size; i ++) {
		free(recvBuffer[i]);		
		free(sendBuffer[i]);
		}
		
   return Rate;

} /* End of function Chaos ( ) */


