#include "mpi-test.h"

double iChaos ( int iSIZE , int TIMES) {

	unsigned char *bBuffer1, *bBuffer2;
	int iSize, iCount, iProcCount, iNumberOfProc, iMyRank, iRemoteProcess;
	double dTime1, dTime2, dTime, dLatency;
	int rank,pool_size,i_am_the_master;
	MPI_Status  *MPIStatus;
	MPI_Request *MPISendRequest, *MPIRecvRequest;
	double Rate;
	int req_count;
	int remote;
	MPI_Comm comm = MPI_COMM_WORLD;
	MPI_Comm_size (comm, &iNumberOfProc );
	MPI_Comm_rank (comm, &iMyRank );
	rank = iMyRank;
	i_am_the_master = (rank == 0);
	pool_size = iNumberOfProc;


	MPIStatus      = ( MPI_Status    * ) malloc ( iNumberOfProc * sizeof(MPI_Status) );
   	MPISendRequest = ( MPI_Request   * ) malloc ( iNumberOfProc * sizeof(MPI_Request) );
   	MPIRecvRequest = ( MPI_Request   * ) malloc ( iNumberOfProc * sizeof(MPI_Request) );
   	bBuffer1       = ( unsigned char * ) malloc ( iNumberOfProc * iSIZE );
   	bBuffer2       = ( unsigned char * ) malloc ( iNumberOfProc * iSIZE );


   	if ( !bBuffer1 || !bBuffer2 || !MPISendRequest || !MPIRecvRequest || !MPIStatus )
		finish( "Can't allocate memory");

	for ( iCount = 0; iCount < (iNumberOfProc * iSIZE); iCount++ )
		bBuffer1 [ iCount ] = bBuffer2 [ iCount ] = iCount;

	MPI_Barrier(comm);


	iSize = iSIZE;
	dTime1 = Wtime ( );

			/* Iterate the send/receive cycle */

         for ( iCount = 0; iCount < TIMES; iCount++ ) 
         {

			req_count = 0;

            for (remote = 0; remote < iNumberOfProc; remote ++ )
				if( remote != iMyRank )  {

					MPI_Isend (&bBuffer1[remote*iSIZE],iSize,MPI_CHAR,
                             remote,iTAG,comm,&MPISendRequest[req_count]);
					MPI_Irecv (&bBuffer2 [remote * iSIZE ], iSize,MPI_CHAR,
                             remote, iTAG,comm,&MPIRecvRequest[req_count]);
					req_count ++;

				}

            MPI_Waitall (req_count, MPISendRequest, MPIStatus );
            MPI_Waitall (req_count, MPIRecvRequest, MPIStatus );

         }
         
	MPI_Barrier(comm);
	dTime2 = Wtime ( ); /* Timing for iMyRank = iROOT */
	dTime = dTime2 - dTime1;
	Rate = ( (double) iSize * 2.0 * TIMES ) / (dTime * MEGABYTE);

   free(bBuffer2);
   free(bBuffer1);
   free(MPIRecvRequest);
   free(MPISendRequest);
   free(MPIStatus);
   fflush(stdout);

   return Rate;

} /* End of function iChaos ( ) */

