
#include "mpi-test.h"

double Ring2 ( int iSIZE , int TIMES)
{
    char* Buffer[4];
	int i;
    int iNumberOfProc, iMyRank, iLeft, iRight, iSize, iCount;
    double dBeginTime, dEndTime, Rate, dUsedTime, dTime, dLatency;
	int rank,pool_size,i_am_the_master;
    MPI_Request MPIRequest [ 4 ];
    MPI_Status MPIStatus [ 4 ];
	MPI_Comm comm = MPI_COMM_WORLD;
    MPI_Comm_size (comm, &iNumberOfProc );
    MPI_Comm_rank (comm, &iMyRank );
	rank = iMyRank;
	i_am_the_master = (rank == 0);
	pool_size = iNumberOfProc;

    iLeft = ( iMyRank + iNumberOfProc - 1) % iNumberOfProc;
    iRight = ( iMyRank + 1 ) % iNumberOfProc;
  

    for(i = 0; i < 4; i ++)
    	if((Buffer[i] = (char *) malloc (iSIZE)) == NULL)
			finish("Can't allocate memory");
	
    iSize = iSIZE;
    MPI_Barrier(comm);
    dBeginTime = Wtime();

	for ( iCount = 0; iCount < TIMES; iCount++ )
	{
               MPI_Isend (Buffer[0], iSize, MPI_CHAR, iLeft,
                          iTAG, MPI_COMM_WORLD, &MPIRequest[0]);
               MPI_Isend (Buffer[2], iSize, MPI_CHAR, iRight,
                          iTAG, MPI_COMM_WORLD, &MPIRequest[2]);
               MPI_Irecv (Buffer[1], iSize, MPI_CHAR, iLeft,
                          iTAG, MPI_COMM_WORLD, &MPIRequest[1]);
               MPI_Irecv (Buffer[3], iSize, MPI_CHAR, iRight,
                          iTAG, MPI_COMM_WORLD, &MPIRequest[3]);

               MPI_Waitall (4, MPIRequest, MPIStatus );
	} 

	MPI_Barrier(comm);
	dEndTime = Wtime ( );
	dUsedTime = dEndTime - dBeginTime;

	Rate = (2.0 * (double) TIMES * iSize)/(dUsedTime*MEGABYTE);

	for(i = 0; i < 4; i ++)
		free(Buffer[i]);

    return Rate;

} /* End of Ring2 ( ) */
